<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<title>High Level Meta Textures</title>
<meta name="generator" content="DocBook XSL Stylesheets V1.78.1">
<link rel="home" href="index.html" title="Cogl 2.0 Reference Manual">
<link rel="up" href="cogl-meta-textures.html" title="Meta Textures">
<link rel="prev" href="cogl-meta-textures.html" title="Meta Textures">
<link rel="next" href="cogl-2.0-experimental-Sub-Textures.html" title="Sub Textures">
<meta name="generator" content="GTK-Doc V1.18.1 (XML mode)">
<link rel="stylesheet" href="style.css" type="text/css">
</head>
<body bgcolor="white" text="black" link="#0000FF" vlink="#840084" alink="#0000FF">
<table class="navigation" id="top" width="100%" summary="Navigation header" cellpadding="2" cellspacing="2">
<tr valign="middle">
<td><a accesskey="p" href="cogl-meta-textures.html"><img src="left.png" width="24" height="24" border="0" alt="Prev"></a></td>
<td><a accesskey="u" href="cogl-meta-textures.html"><img src="up.png" width="24" height="24" border="0" alt="Up"></a></td>
<td><a accesskey="h" href="index.html"><img src="home.png" width="24" height="24" border="0" alt="Home"></a></td>
<th width="100%" align="center">Cogl 2.0 Reference Manual</th>
<td><a accesskey="n" href="cogl-2.0-experimental-Sub-Textures.html"><img src="right.png" width="24" height="24" border="0" alt="Next"></a></td>
</tr>
<tr><td colspan="5" class="shortcuts">
<a href="#cogl-2.0-experimental-High-Level-Meta-Textures.synopsis" class="shortcut">Top</a>
                   | 
                  <a href="#cogl-2.0-experimental-High-Level-Meta-Textures.description" class="shortcut">Description</a>
</td></tr>
</table>
<div class="refentry">
<a name="cogl-2.0-experimental-High-Level-Meta-Textures"></a><div class="titlepage"></div>
<div class="refnamediv"><table width="100%"><tr>
<td valign="top">
<h2><span class="refentrytitle"><a name="cogl-2.0-experimental-High-Level-Meta-Textures.top_of_page"></a>High Level Meta Textures</span></h2>
<p>High Level Meta Textures — Interface for high-level textures built from
                    low-level textures like <a class="link" href="cogl-2.0-experimental-2D-textures.html#CoglTexture2D" title="CoglTexture2D"><span class="type">CoglTexture2D</span></a> and
                    <a class="link" href="cogl-2.0-experimental-3D-textures.html#CoglTexture3D" title="CoglTexture3D"><span class="type">CoglTexture3D</span></a>.</p>
</td>
<td valign="top" align="right"></td>
</tr></table></div>
<div class="refsynopsisdiv">
<a name="cogl-2.0-experimental-High-Level-Meta-Textures.synopsis"></a><h2>Synopsis</h2>
<pre class="synopsis">                    <a class="link" href="cogl-2.0-experimental-High-Level-Meta-Textures.html#CoglMetaTexture" title="CoglMetaTexture">CoglMetaTexture</a>;
<span class="returnvalue">void</span>                (<a class="link" href="cogl-2.0-experimental-High-Level-Meta-Textures.html#CoglMetaTextureCallback" title="CoglMetaTextureCallback ()">*CoglMetaTextureCallback</a>)          (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-The-Texture-Interface.html#CoglTexture" title="CoglTexture"><span class="type">CoglTexture</span></a> *sub_texture</code></em>,
                                                         <em class="parameter"><code>const <span class="type">float</span> *sub_texture_coords</code></em>,
                                                         <em class="parameter"><code>const <span class="type">float</span> *meta_coords</code></em>,
                                                         <em class="parameter"><code><span class="type">void</span> *user_data</code></em>);
<span class="returnvalue">void</span>                <a class="link" href="cogl-2.0-experimental-High-Level-Meta-Textures.html#cogl-meta-texture-foreach-in-region" title="cogl_meta_texture_foreach_in_region ()">cogl_meta_texture_foreach_in_region</a> (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-High-Level-Meta-Textures.html#CoglMetaTexture" title="CoglMetaTexture"><span class="type">CoglMetaTexture</span></a> *meta_texture</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> tx_1</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> ty_1</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> tx_2</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> ty_2</code></em>,
                                                         <em class="parameter"><code><a class="link" href="cogl-2.0-experimental-Pipeline.html#CoglPipelineWrapMode" title="enum CoglPipelineWrapMode"><span class="type">CoglPipelineWrapMode</span></a> wrap_s</code></em>,
                                                         <em class="parameter"><code><a class="link" href="cogl-2.0-experimental-Pipeline.html#CoglPipelineWrapMode" title="enum CoglPipelineWrapMode"><span class="type">CoglPipelineWrapMode</span></a> wrap_t</code></em>,
                                                         <em class="parameter"><code><a class="link" href="cogl-2.0-experimental-High-Level-Meta-Textures.html#CoglMetaTextureCallback" title="CoglMetaTextureCallback ()"><span class="type">CoglMetaTextureCallback</span></a> callback</code></em>,
                                                         <em class="parameter"><code><span class="type">void</span> *user_data</code></em>);
</pre>
</div>
<div class="refsect1">
<a name="cogl-2.0-experimental-High-Level-Meta-Textures.description"></a><h2>Description</h2>
<p>
Cogl helps to make it easy to deal with high level textures such
as <span class="type">CoglAtlasTexture</span>s, <a class="link" href="cogl-2.0-experimental-Sub-Textures.html#CoglSubTexture" title="CoglSubTexture"><span class="type">CoglSubTexture</span></a>s,
<a class="link" href="cogl-2.0-experimental-X11-Texture-From-Pixmap.html#CoglTexturePixmapX11" title="CoglTexturePixmapX11"><span class="type">CoglTexturePixmapX11</span></a> textures and <a class="link" href="cogl-2.0-experimental-Sliced-Textures.html#CoglTexture2DSliced" title="CoglTexture2DSliced"><span class="type">CoglTexture2DSliced</span></a> textures
consistently.
</p>
<p>
A <a class="link" href="cogl-2.0-experimental-High-Level-Meta-Textures.html#CoglMetaTexture" title="CoglMetaTexture"><span class="type">CoglMetaTexture</span></a> is a texture that might internally be
represented by one or more low-level <a class="link" href="cogl-2.0-experimental-The-Texture-Interface.html#CoglTexture" title="CoglTexture"><span class="type">CoglTexture</span></a>s
such as <a class="link" href="cogl-2.0-experimental-2D-textures.html#CoglTexture2D" title="CoglTexture2D"><span class="type">CoglTexture2D</span></a> or <a class="link" href="cogl-2.0-experimental-3D-textures.html#CoglTexture3D" title="CoglTexture3D"><span class="type">CoglTexture3D</span></a>. These low-level textures
are the only ones that a GPU really understands but because
applications often want more high-level texture abstractions
(such as storing multiple textures inside one larger "atlas"
texture) it's desirable to be able to deal with these
using a common interface.
</p>
<p>
For example the GPU is not able to automatically handle repeating a
texture that is part of a larger atlas texture but if you use
<a class="link" href="cogl-2.0-experimental-Pipeline.html#COGL-PIPELINE-WRAP-MODE-REPEAT:CAPS"><code class="literal">COGL_PIPELINE_WRAP_MODE_REPEAT</code></a> with an atlas texture when drawing
with <a class="link" href="cogl-2.0-experimental-Rectangles.html#cogl-rectangle" title="cogl_rectangle ()"><code class="function">cogl_rectangle()</code></a> you should see that it "Just Works™" - at
least if you don't use multi-texturing. The reason this works is
because <a class="link" href="cogl-2.0-experimental-Rectangles.html#cogl-rectangle" title="cogl_rectangle ()"><code class="function">cogl_rectangle()</code></a> internally understands the <a class="link" href="cogl-2.0-experimental-High-Level-Meta-Textures.html#CoglMetaTexture" title="CoglMetaTexture"><span class="type">CoglMetaTexture</span></a>
interface and is able to manually resolve the low-level textures
using this interface and by making multiple draw calls it can
emulate the texture repeat modes.
</p>
<p>
Cogl doesn't aim to pretend that meta-textures are just like real
textures because it would get extremely complex to try and emulate
low-level GPU semantics transparently for these textures.  The low
level drawing APIs of Cogl, such as <a class="link" href="cogl-2.0-experimental-Primitives.html#cogl-primitive-draw" title="cogl_primitive_draw ()"><code class="function">cogl_primitive_draw()</code></a> don't
actually know anything about the <a class="link" href="cogl-2.0-experimental-High-Level-Meta-Textures.html#CoglMetaTexture" title="CoglMetaTexture"><span class="type">CoglMetaTexture</span></a> interface and its
the developer's responsibility to resolve all textures referenced
by a <a class="link" href="cogl-2.0-experimental-Pipeline.html#CoglPipeline" title="CoglPipeline"><span class="type">CoglPipeline</span></a> to low-level textures before drawing.
</p>
<p>
If you want to develop custom primitive APIs like
<a class="link" href="cogl-2.0-experimental-CoglFramebuffer---The-Framebuffer-Interface.html#cogl-framebuffer-draw-rectangle" title="cogl_framebuffer_draw_rectangle ()"><code class="function">cogl_framebuffer_draw_rectangle()</code></a> and you want to support drawing
with <span class="type">CoglAtlasTexture</span>s or <a class="link" href="cogl-2.0-experimental-Sub-Textures.html#CoglSubTexture" title="CoglSubTexture"><span class="type">CoglSubTexture</span></a>s for
example, then you will need to use this <a class="link" href="cogl-2.0-experimental-High-Level-Meta-Textures.html#CoglMetaTexture" title="CoglMetaTexture"><span class="type">CoglMetaTexture</span></a> interface
to be able to resolve high-level textures into low-level textures
before drawing with Cogl's low-level drawing APIs such as
<a class="link" href="cogl-2.0-experimental-Primitives.html#cogl-primitive-draw" title="cogl_primitive_draw ()"><code class="function">cogl_primitive_draw()</code></a>.
</p>
<p>
</p>
<div class="note" style="margin-left: 0.5in; margin-right: 0.5in;">
<h3 class="title">Note</h3>Most developers won't need to use this interface directly
but still it is worth understanding the distinction between
low-level and meta textures because you may find other references
in the documentation that detail limitations of using
meta-textures.</div>
<p>
</p>
</div>
<div class="refsect1">
<a name="cogl-2.0-experimental-High-Level-Meta-Textures.details"></a><h2>Details</h2>
<div class="refsect2">
<a name="CoglMetaTexture"></a><h3>CoglMetaTexture</h3>
<pre class="programlisting">typedef struct _CoglMetaTexture CoglMetaTexture;</pre>
</div>
<hr>
<div class="refsect2">
<a name="CoglMetaTextureCallback"></a><h3>CoglMetaTextureCallback ()</h3>
<pre class="programlisting"><span class="returnvalue">void</span>                (*CoglMetaTextureCallback)          (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-The-Texture-Interface.html#CoglTexture" title="CoglTexture"><span class="type">CoglTexture</span></a> *sub_texture</code></em>,
                                                         <em class="parameter"><code>const <span class="type">float</span> *sub_texture_coords</code></em>,
                                                         <em class="parameter"><code>const <span class="type">float</span> *meta_coords</code></em>,
                                                         <em class="parameter"><code><span class="type">void</span> *user_data</code></em>);</pre>
<p>
A callback used with <a class="link" href="cogl-2.0-experimental-High-Level-Meta-Textures.html#cogl-meta-texture-foreach-in-region" title="cogl_meta_texture_foreach_in_region ()"><code class="function">cogl_meta_texture_foreach_in_region()</code></a> to
retrieve details of all the low-level <a class="link" href="cogl-2.0-experimental-The-Texture-Interface.html#CoglTexture" title="CoglTexture"><span class="type">CoglTexture</span></a>s that
make up a given <a class="link" href="cogl-2.0-experimental-High-Level-Meta-Textures.html#CoglMetaTexture" title="CoglMetaTexture"><span class="type">CoglMetaTexture</span></a>.
</p>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody>
<tr>
<td><p><span class="term"><em class="parameter"><code>sub_texture</code></em> :</span></p></td>
<td>A low-level <a class="link" href="cogl-2.0-experimental-The-Texture-Interface.html#CoglTexture" title="CoglTexture"><span class="type">CoglTexture</span></a> making up part of a
<a class="link" href="cogl-2.0-experimental-High-Level-Meta-Textures.html#CoglMetaTexture" title="CoglMetaTexture"><span class="type">CoglMetaTexture</span></a>.</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>sub_texture_coords</code></em> :</span></p></td>
<td>A float 4-tuple ordered like
(tx1,ty1,tx2,ty2) defining what region of the
current <em class="parameter"><code>sub_texture</code></em> maps to a sub-region of a
<a class="link" href="cogl-2.0-experimental-High-Level-Meta-Textures.html#CoglMetaTexture" title="CoglMetaTexture"><span class="type">CoglMetaTexture</span></a>. (tx1,ty1) is the top-left
sub-region coordinate and (tx2,ty2) is the
bottom-right. These are low-level texture
coordinates.</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>meta_coords</code></em> :</span></p></td>
<td>A float 4-tuple ordered like (tx1,ty1,tx2,ty2)
defining what sub-region of a <a class="link" href="cogl-2.0-experimental-High-Level-Meta-Textures.html#CoglMetaTexture" title="CoglMetaTexture"><span class="type">CoglMetaTexture</span></a> this
low-level <em class="parameter"><code>sub_texture</code></em> maps too. (tx1,ty1) is
the top-left sub-region coordinate and (tx2,ty2) is
the bottom-right. These are high-level meta-texture
coordinates.</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>user_data</code></em> :</span></p></td>
<td>A private pointer passed to
<a class="link" href="cogl-2.0-experimental-High-Level-Meta-Textures.html#cogl-meta-texture-foreach-in-region" title="cogl_meta_texture_foreach_in_region ()"><code class="function">cogl_meta_texture_foreach_in_region()</code></a>.</td>
</tr>
</tbody>
</table></div>
<p class="since">Since 1.10</p>
<p class="stability">Stability Level: Unstable</p>
</div>
<hr>
<div class="refsect2">
<a name="cogl-meta-texture-foreach-in-region"></a><h3>cogl_meta_texture_foreach_in_region ()</h3>
<pre class="programlisting"><span class="returnvalue">void</span>                cogl_meta_texture_foreach_in_region (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-High-Level-Meta-Textures.html#CoglMetaTexture" title="CoglMetaTexture"><span class="type">CoglMetaTexture</span></a> *meta_texture</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> tx_1</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> ty_1</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> tx_2</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> ty_2</code></em>,
                                                         <em class="parameter"><code><a class="link" href="cogl-2.0-experimental-Pipeline.html#CoglPipelineWrapMode" title="enum CoglPipelineWrapMode"><span class="type">CoglPipelineWrapMode</span></a> wrap_s</code></em>,
                                                         <em class="parameter"><code><a class="link" href="cogl-2.0-experimental-Pipeline.html#CoglPipelineWrapMode" title="enum CoglPipelineWrapMode"><span class="type">CoglPipelineWrapMode</span></a> wrap_t</code></em>,
                                                         <em class="parameter"><code><a class="link" href="cogl-2.0-experimental-High-Level-Meta-Textures.html#CoglMetaTextureCallback" title="CoglMetaTextureCallback ()"><span class="type">CoglMetaTextureCallback</span></a> callback</code></em>,
                                                         <em class="parameter"><code><span class="type">void</span> *user_data</code></em>);</pre>
<p>
Allows you to manually iterate the low-level textures that define a
given region of a high-level <a class="link" href="cogl-2.0-experimental-High-Level-Meta-Textures.html#CoglMetaTexture" title="CoglMetaTexture"><span class="type">CoglMetaTexture</span></a>.
</p>
<p>
For example <a class="link" href="cogl-2.0-experimental-Sliced-Textures.html#cogl-texture-2d-sliced-new-with-size" title="cogl_texture_2d_sliced_new_with_size ()"><code class="function">cogl_texture_2d_sliced_new_with_size()</code></a> can be used to
create a meta texture that may slice a large image into multiple,
smaller power-of-two sized textures. These high level textures are
not directly understood by a GPU and so this API must be used to
manually resolve the underlying textures for drawing.
</p>
<p>
All high level textures (<span class="type">CoglAtlasTexture</span>, <a class="link" href="cogl-2.0-experimental-Sub-Textures.html#CoglSubTexture" title="CoglSubTexture"><span class="type">CoglSubTexture</span></a>,
<a class="link" href="cogl-2.0-experimental-X11-Texture-From-Pixmap.html#CoglTexturePixmapX11" title="CoglTexturePixmapX11"><span class="type">CoglTexturePixmapX11</span></a>, and <a class="link" href="cogl-2.0-experimental-Sliced-Textures.html#CoglTexture2DSliced" title="CoglTexture2DSliced"><span class="type">CoglTexture2DSliced</span></a>) can be handled
consistently using this interface which greately simplifies
implementing primitives that support all texture types.
</p>
<p>
For example if you use the <a class="link" href="cogl-2.0-experimental-Rectangles.html#cogl-rectangle" title="cogl_rectangle ()"><code class="function">cogl_rectangle()</code></a> API then Cogl will
internally use this API to resolve the low level textures of any
meta textures you have associated with CoglPipeline layers.
</p>
<p>
</p>
<div class="note" style="margin-left: 0.5in; margin-right: 0.5in;">
<h3 class="title">Note</h3>The low level drawing APIs such as <a class="link" href="cogl-2.0-experimental-Primitives.html#cogl-primitive-draw" title="cogl_primitive_draw ()"><code class="function">cogl_primitive_draw()</code></a>
don't understand the <a class="link" href="cogl-2.0-experimental-High-Level-Meta-Textures.html#CoglMetaTexture" title="CoglMetaTexture"><span class="type">CoglMetaTexture</span></a> interface and so it is your
responsibility to use this API to resolve all CoglPipeline textures
into low-level textures before drawing.</div>
<p>
</p>
<p>
For each low-level texture that makes up part of the given region
of the <em class="parameter"><code>meta_texture</code></em>, <em class="parameter"><code>callback</code></em> is called specifying how the
low-level texture maps to the original region.
</p>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody>
<tr>
<td><p><span class="term"><em class="parameter"><code>meta_texture</code></em> :</span></p></td>
<td>An object implementing the <a class="link" href="cogl-2.0-experimental-High-Level-Meta-Textures.html#CoglMetaTexture" title="CoglMetaTexture"><span class="type">CoglMetaTexture</span></a>
interface.</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>tx_1</code></em> :</span></p></td>
<td>The top-left x coordinate of the region to iterate</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>ty_1</code></em> :</span></p></td>
<td>The top-left y coordinate of the region to iterate</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>tx_2</code></em> :</span></p></td>
<td>The bottom-right x coordinate of the region to iterate</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>ty_2</code></em> :</span></p></td>
<td>The bottom-right y coordinate of the region to iterate</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>wrap_s</code></em> :</span></p></td>
<td>The wrap mode for the x-axis</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>wrap_t</code></em> :</span></p></td>
<td>The wrap mode for the y-axis</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>callback</code></em> :</span></p></td>
<td>A <a class="link" href="cogl-2.0-experimental-High-Level-Meta-Textures.html#CoglMetaTextureCallback" title="CoglMetaTextureCallback ()"><span class="type">CoglMetaTextureCallback</span></a> pointer to be called
for each low-level texture within the specified region.</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>user_data</code></em> :</span></p></td>
<td>A private pointer that is passed to <em class="parameter"><code>callback</code></em>.</td>
</tr>
</tbody>
</table></div>
<p class="since">Since 1.10</p>
<p class="stability">Stability Level: Unstable</p>
</div>
</div>
</div>
<div class="footer">
<hr>
          Generated by GTK-Doc V1.18.1</div>
</body>
</html>